{ pkgs, theme, ... }:
let
  flavor = theme.flavor;
in
{
  environment.systemPackages = with pkgs; [
    (catppuccin-sddm.override {
      flavor = flavor;
      font = theme.nerdFont;
      fontSize = "9";
      background = builtins.toString ../assets/catppuccin_high.png;
      loginBackground = true;
    })
  ];

  services.displayManager.sddm = {
    enable = true;
    theme = "catppuccin-${flavor}";
    wayland.enable = true;
    package = pkgs.kdePackages.sddm;
  };
}
